// BMFBioUPIDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BMFBioUPIDemo.h"
#include "BMFBioUPIDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "io.h"
#include "fcntl.h"
#include <sys/stat.h>



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBMFBioUPIDemoDlg dialog

CBMFBioUPIDemoDlg::CBMFBioUPIDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBMFBioUPIDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBMFBioUPIDemoDlg)
	m_access_relay = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	int	i;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	number_row = 0;
	current_row = -1;
	status_click = 0;

	for(i = 0; i < MAX_USERS; i++) {
		strnset((char *)(users[i].fname),0,15);
		strnset((char *)(users[i].lname),0,15);
		users[i].ID   = 0;
	}

	number_tmp = 0;
	current_tmp = -1;

	for(i = 0; i < MAX_USERS; i++) {
		strnset((char *)(tempu[i].temp), 0,2048);
		tempu[i].flag = 0;
		tempu[i].ID   = 0;
	}

	numref_row = 0;
	for(i = 0; i < 90; i++) {
		strnset((char *)(cref[i].ipscn), 0, 16);
		strnset((char *)(cref[i].iprel), 0, 16);
		cref[i].prrel   = 0;
		cref[i].relcontact = 0;
	}

}

void CBMFBioUPIDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBMFBioUPIDemoDlg)
	DDX_Control(pDX, IDC_LISTMSG, m_ListMsg);
	DDX_Control(pDX, IDC_LISTREF, m_ListRef);
	DDX_Control(pDX, IDC_LISTUSERS, m_ListUsers);
	DDX_Control(pDX, IDC_TRANING, m_Training);
	DDX_Check(pDX, IDC_ACCESSRELAY, m_access_relay);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBMFBioUPIDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CBMFBioUPIDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_TRANING, OnTraning)
	ON_BN_CLICKED(IDC_ADDUSER, OnAdduser)
	ON_BN_CLICKED(IDC_MODIFYUSER, OnModifyuser)
	ON_BN_CLICKED(IDC_DELETEUSER, OnDeleteuser)
	ON_BN_CLICKED(IDC_ENROLLMENT, OnEnrollment)
	ON_BN_CLICKED(IDC_IDEN, OnIden)
	ON_NOTIFY(NM_CLICK, IDC_LISTUSERS, OnClickListusers)
	ON_BN_CLICKED(IDC_SAVELIST, OnSavelist)
	ON_BN_CLICKED(IDC_LOADFILE, OnLoadfile)
	ON_NOTIFY(LVN_KEYDOWN, IDC_LISTUSERS, OnKeydownListusers)
	ON_WM_SETCURSOR()
	ON_NOTIFY(NM_SETFOCUS, IDC_LISTUSERS, OnSetfocusListusers)
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_VKEYTOITEM()
	ON_BN_CLICKED(IDC_ADDREF, OnAddref)
	ON_BN_CLICKED(IDC_DELREF, OnDelref)
	ON_NOTIFY(NM_CLICK, IDC_LISTREF, OnClickListref)
	ON_BN_CLICKED(IDC_SERVER, OnServer)
	ON_NOTIFY(NM_CLICK, IDC_LISTMSG, OnClickListmsg)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_GREEN, OnGreen)
	ON_BN_CLICKED(IDC_RED, OnRed)
	ON_BN_CLICKED(IDC_ACCESSRELAY, OnAccessrelay)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CBMFBioUPIDemoDlg message handlers

BOOL CBMFBioUPIDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	CWnd* pWnd = GetDlgItem(IDC_LISTUSERS);
	
	CRect rect;
	pWnd->GetWindowRect(&rect);
	
	m_ListUsers.InsertColumn(0, _T("First Name"),  LVCFMT_LEFT,  rect.Width() / 4);
	m_ListUsers.InsertColumn(1, _T("Last Name"),   LVCFMT_LEFT,  rect.Width() / 4);
	m_ListUsers.InsertColumn(2, _T("ID Number"),   LVCFMT_CENTER, rect.Width() / 4);
	m_ListUsers.InsertColumn(3, _T("Template"),    LVCFMT_LEFT,  rect.Width() / 4);

	ListView_SetExtendedListViewStyle( m_ListUsers, LVS_EX_FULLROWSELECT);


	CWnd* pWnd1 = GetDlgItem(IDC_LISTREF);
	
	CRect rect1;
	pWnd1->GetWindowRect(&rect1);

	m_ListRef.InsertColumn(0, _T("IP Scanner"), LVCFMT_CENTER, rect1.Width() / 5 + 35);
	m_ListRef.InsertColumn(1, _T("IP relay"),   LVCFMT_CENTER, rect1.Width() / 5 + 35);
	m_ListRef.InsertColumn(2, _T("Port relay"), LVCFMT_CENTER, rect1.Width() / 5-10);
	m_ListRef.InsertColumn(3, _T("N"),		LVCFMT_CENTER, rect1.Width() / 5 - 30);
	m_ListRef.InsertColumn(3, _T("Delay"),			LVCFMT_CENTER, rect1.Width() / 5 - 30);

	ListView_SetExtendedListViewStyle( m_ListRef, LVS_EX_FULLROWSELECT);


	CWnd* pWnd2 = GetDlgItem(IDC_LISTMSG);
	
	CRect rect2;
	pWnd2->GetWindowRect(&rect2);

	m_ListMsg.InsertColumn(0, _T("Events"), LVCFMT_CENTER, rect2.Width());

	ListView_SetExtendedListViewStyle( m_ListMsg, LVS_EX_FULLROWSELECT);

	nummsg_row = 0;


	strcpy(ipaddress,"192.168.100.13");
	strcpy(ipport,"3000");

	SetDlgItemText(IDC_IPADDRESS1,ipaddress);
	SetDlgItemText(IDC_PORT,ipport);

	strcpy(ipaddress,"192.168.100.135");
	strcpy(ipport,"5000");
	SetDlgItemText(IDC_IPADDRESS2,ipaddress);
	SetDlgItemText(IDC_PORT2,ipport);

	m_access_relay = 1;
	CheckDlgButton(IDC_ACCESSRELAY, m_access_relay);

	
	// TODO: Add extra initialization here
	m_IsTraining = FALSE;
	m_IsEnroll= FALSE;
	m_IsComp1to1= FALSE;
	m_IsComp1toN= FALSE;

	m_green = FALSE;
	m_red = FALSE;

	ScanThread = NULL;
	ScanThreadServ = NULL;

	UpdateData(FALSE);


	pimg = (unsigned char *)malloc(300000);
	if ( pimg == NULL )	return FALSE;
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBMFBioUPIDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBMFBioUPIDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBMFBioUPIDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CBMFBioUPIDemoDlg::OnTraning() 
{
// TODO: Add your control notification handler code here
if ( m_IsTraining == TRUE ) {
	m_IsTraining = FALSE;
	SetDlgItemText(IDC_TRANING,"Training");
	SetDlgItemText(IDC_STATUS, "");
	GetDlgItem(IDC_IDEN)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENROLLMENT)->EnableWindow(TRUE);
	return;
}
SetDlgItemText(IDC_TRANING,"Stop");
GetDlgItem(IDC_IDEN)->EnableWindow(FALSE);
GetDlgItem(IDC_ENROLLMENT)->EnableWindow(FALSE);

m_IsTraining = TRUE;

m_IsEnroll = FALSE;	
m_IsComp1to1= FALSE;
m_IsComp1toN= FALSE;

SetDlgItemText(IDC_STATUS,    "Training");
SetDlgItemText(IDC_STATUSINFO,"");
}



void CBMFBioUPIDemoDlg::MyPaint(void)
{
	short	color;

	CWnd* pWnd = GetDlgItem(IDC_IMAGE);
	CClientDC pControlDC(pWnd);
	RECT	rect;

	int	deltaX=1;
	int	deltaY=4;

	if  ( pimg == NULL )	return;


	pWnd->GetWindowRect(&rect);

	rect.left=5; 
	rect.top=15;
	rect.bottom = rect.top  + Himg-deltaY;
	rect.right  = rect.left + Wimg-deltaX;

	CBitmap * oldBitmap;
	CRect clientRect;

	CDC * m_pdcDisplayMemory = new CDC;
	CBitmap * m_pBitmap = new CBitmap;
			
	if (m_pdcDisplayMemory->GetSafeHdc() == NULL) 
	{
		m_pdcDisplayMemory->CreateCompatibleDC(&pControlDC);
		m_pBitmap->CreateCompatibleBitmap(
				&pControlDC
				,Wimg-deltaX 
				,Himg-deltaY
				);

		oldBitmap = m_pdcDisplayMemory->SelectObject(m_pBitmap);
	}
	int x0 = rect.left;
	int y0 = rect.top;
	int Beg=0;
		
	for(unsigned int j=0; j<(unsigned)(Himg-deltaY);j++)
	{
		for(unsigned int i=0;i<(unsigned)(Wimg-deltaX);i++)
		{
			color = pimg[Beg+i+j*Wimg];
			m_pdcDisplayMemory->SetPixel(i,j,RGB(color,color,color)); 
		}
	}

	pControlDC.StretchBlt(x0, y0, 
			Wimg-deltaX , 
			Himg-deltaY, 
			m_pdcDisplayMemory, 
			0, 0, 
			Wimg-deltaX , 
			Himg-deltaY, 
			SRCCOPY);

	delete m_pdcDisplayMemory;
	delete m_pBitmap;
		
}

void CBMFBioUPIDemoDlg::OnOK() 
{
	// TODO: Add extra validation here

	TreatStatus = FALSE;
	Sleep(500);
	if ( ScanThread !=NULL ) {
		WaitForSingleObject(ScanThread->m_hThread,INFINITE);
	}

	TreatStatusServ = FALSE;
	Sleep(500);
	if ( ScanThreadServ !=NULL ) {
		WaitForSingleObject(ScanThreadServ->m_hThread,INFINITE);
	}


	if ( pimg != NULL )	free(pimg);
	pimg = NULL;

	CDialog::OnOK();
}


void CBMFBioUPIDemoDlg::OnAdduser() 
{
	int	i, j, stat;
	// TODO: Add your control notification handler code here
	char buf[25];
	CString	fname;
	CString	lname;

	GetDlgItemText(IDC_EDITFNAME, fname);
	GetDlgItemText(IDC_EDITLNAME, lname);

	for(i = 1; i < 91; i++) {
		stat = 0;
		for(j = 0; j < number_row; j++) {
			if ( users[j].ID == i )	{ stat = 1; break; }
		}
		if ( stat == 0 ) {
			users[number_row].ID = i;
			break;
		}
	}

	strcpy((char *)users[number_row].fname,	fname.GetBuffer(0));
	strcpy((char *)users[number_row].lname,	lname.GetBuffer(0));

	//users[number_row].ID = number_row;
	m_ListUsers.InsertItem( number_row, fname );
		
	m_ListUsers.SetItemText( number_row, 0, (char *)users[number_row].fname);
	m_ListUsers.SetItemText( number_row, 1, (char *)users[number_row].lname);
	sprintf(buf,"%d", users[number_row].ID);
	m_ListUsers.SetItemText( number_row, 2, buf  );
	m_ListUsers.SetItemText( number_row, 3, "No" );

	number_row++;
}

void CBMFBioUPIDemoDlg::OnModifyuser() 
{
	if ( current_row == -1 )	{
		MessageBox("The user isn't selected", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}
	if ( status_click == 0 ) {
		MessageBox("Please, select line by mouse", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}

	// TODO: Add your control notification handler code here
	CString	fname(users[current_row].fname);
	CString	lname(users[current_row].lname);

	GetDlgItemText(IDC_EDITFNAME, fname);
	GetDlgItemText(IDC_EDITLNAME, lname);

	strcpy((char *)users[current_row].fname, fname.GetBuffer(0));
	strcpy((char *)users[current_row].lname, lname.GetBuffer(0));

	m_ListUsers.SetItemText( current_row, 0, fname);
	m_ListUsers.SetItemText( current_row, 1, lname);
	
}

void CBMFBioUPIDemoDlg::OnDeleteuser() 
{
	// TODO: Add your control notification handler code here
	int	ID;

	if ( current_row == -1 )	{
		MessageBox("The user isn't selected", "Delete", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}
	if ( status_click == 0 ) {
		MessageBox("Please, select line by mouse", "Delete", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}

	ID = users[current_row].ID;
	
	for(int i = current_row; i < (number_row-1); i++) {
		users[i] = users[i+1];
	}

	m_ListUsers.DeleteItem(current_row);
	number_row--;

	Deletetmp(ID);
}

/*
*/
void CBMFBioUPIDemoDlg::Deletetmp(int ID)
{
int	i, j;

for(i = 0; i < number_tmp; i++) {
	if ( tempu[i].ID == ID ) {
		for(j = i; j < (number_tmp-1); j++) {
			tempu[j] = tempu[j+1];
		}
		number_tmp--;
	}
}

}

void CBMFBioUPIDemoDlg::OnEnrollment() 
{
	// TODO: Add your control notification handler code here

if ( current_row == -1 )	{
	MessageBox("The user isn't selected", "Enrollment", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
	return;
}

if ( m_IsEnroll == TRUE ) {
	m_IsEnroll  = FALSE; 
	SetDlgItemText(IDC_ENROLLMENT,"Enrollment");
	SetDlgItemText(IDC_STATUS, "");
	GetDlgItem(IDC_TRANING)->EnableWindow(TRUE);
	GetDlgItem(IDC_IDEN)->EnableWindow(TRUE);
	return;
}
SetDlgItemText(IDC_ENROLLMENT,"Stop");
GetDlgItem(IDC_TRANING)->EnableWindow(FALSE);
GetDlgItem(IDC_IDEN)->EnableWindow(FALSE);

m_IsEnroll = TRUE;	

m_IsTraining = FALSE;
m_IsComp1to1= FALSE;
m_IsComp1toN= FALSE;

counter = 0;
countmis = 0;
status  = 0;

SetDlgItemText(IDC_STATUS,    "Enrollment");
SetDlgItemText(IDC_STATUSINFO,"Please, put your finger on the scanner");
}


void CBMFBioUPIDemoDlg::OnIden() 
{
// TODO: Add your control notification handler code here

if ( m_IsComp1to1 == TRUE ) {
	m_IsComp1to1 =FALSE; 
	SetDlgItemText(IDC_IDEN,"Identification");
	SetDlgItemText(IDC_STATUS, "");
	GetDlgItem(IDC_TRANING)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENROLLMENT)->EnableWindow(TRUE);
	return;
}
SetDlgItemText(IDC_IDEN,"Stop");
GetDlgItem(IDC_TRANING)->EnableWindow(FALSE);
GetDlgItem(IDC_ENROLLMENT)->EnableWindow(FALSE);

m_IsComp1to1= TRUE;

m_IsTraining = FALSE;
m_IsEnroll   = FALSE;	
m_IsComp1toN = FALSE;

counter = 0;
countmis = 0;

SetDlgItemText(IDC_STATUS,    "Identification");
SetDlgItemText(IDC_STATUSINFO,"");
}


#include "io.h"
#include "fcntl.h"

unsigned char fb[125000];
unsigned char ft[2049];

int	CBMFBioUPIDemoDlg::CalcTemplates(int ID)
{
int	i, ret = 0;

for(i = 0; i < number_tmp; i++) {
	if ( tempu[i].ID == ID )	ret++;
}
return	ret;
}

void CBMFBioUPIDemoDlg::OnClickListusers(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CString	str;
	
	*pResult = 0;

	current_row = m_ListUsers.GetNextItem( -1, LVNI_ALL | LVNI_FOCUSED);

	if ( current_row == -1 )	return;

	status_click = 1;

	str = m_ListUsers.GetItemText(current_row, 0);
	SetDlgItemText(IDC_EDITFNAME,    str);
	
	str = m_ListUsers.GetItemText(current_row, 1);
	SetDlgItemText(IDC_EDITLNAME,    str);

}

void CBMFBioUPIDemoDlg::OnSavelist() 
{
	// TODO: Add your control notification handler code here
	int	i, handle;
	CString	str;

	handle = _open("@saveu.bin", O_CREAT | O_WRONLY | O_BINARY | O_TRUNC, 0666 );
	if ( handle == - 1 )	return;

	for(i = 0; i < number_row; i++) {

		str = m_ListUsers.GetItemText(i, 0);
		memcpy(users[i].fname,str.GetBuffer(0),15);

		str = m_ListUsers.GetItemText(i, 1);
		memcpy(users[i].lname,str.GetBuffer(0),15);

		_write(handle,(void *)(&users[i]), sizeof(UserData));
	}

	_close(handle);

	handle = _open("@savet.bin", O_CREAT | O_WRONLY | O_BINARY | O_TRUNC, 0666 );
	if ( handle == - 1 )	return;

	for(i = 0; i < number_tmp; i++) {
		_write(handle,(void *)(&tempu[i]), sizeof(TempData));
	}

	_close(handle);

	handle = _open("@saver.bin", O_CREAT | O_WRONLY | O_BINARY | O_TRUNC, 0666 );
	if ( handle == - 1 )	return;

	for(i = 0; i < numref_row; i++) {
		_write(handle,(void *)(&cref[i]), sizeof(ConRef));
	}

	_close(handle);


	
}

void CBMFBioUPIDemoDlg::OnLoadfile() 
{
	// TODO: Add your control notification handler code here
	char	buf[25], bid[25];
	int	i, handle, size, ret;

	handle = _open("@saveu.bin",O_RDONLY|O_BINARY);
	if ( handle == -1 )	return;

	size = filelength(handle);

	number_row = size/sizeof(UserData);

	m_ListUsers.DeleteAllItems();
	ASSERT(m_ListUsers.GetItemCount() == 0);

	for(i = 0; i < number_row; i++) {
		_read(handle, (void *)(&users[i]), sizeof(UserData));

		m_ListUsers.InsertItem( i, (char *)users[i].fname );
	
		m_ListUsers.SetItemText( i, 0, (char *)users[i].fname);
		m_ListUsers.SetItemText( i, 1, (char *)users[i].lname);
		sprintf(buf,"%d", users[i].ID);
		m_ListUsers.SetItemText( i, 2, buf  );
		//m_ListUsers.SetItemText( i, 3, buf  );
	}

	_close(handle);

	handle = _open("@savet.bin",O_RDONLY|O_BINARY);
	if ( handle == -1 )	return;

	size = filelength(handle);

	number_tmp = size/sizeof(TempData);

	for(i = 0; i < number_tmp; i++) {
		_read(handle, (void *)(&tempu[i]), sizeof(TempData));
	}

	_close(handle);

	for(i = 0; i < number_row; i++) {
		ret = CalcTemplates(users[i].ID);
		if ( ret == 0 )	sprintf(bid,"No (%d)",  ret);
		else			sprintf(bid,"Yes (%d)", ret);
		m_ListUsers.SetItemText( i, 3, bid  );
	}

	//---

	handle = _open("@saver.bin",O_RDONLY|O_BINARY);
	if ( handle == -1 )	return;

	size = filelength(handle);

	numref_row = size/sizeof(ConRef);

	m_ListRef.DeleteAllItems();
	ASSERT(m_ListRef.GetItemCount() == 0);

	for(i = 0; i < numref_row; i++) {
		_read(handle, (void *)(&cref[i]), sizeof(ConRef));

		m_ListRef.InsertItem( i, (char *)cref[i].ipscn );
	
		m_ListRef.SetItemText( i, 0, (char *)cref[i].ipscn);
		m_ListRef.SetItemText( i, 1, (char *)cref[i].iprel);

		sprintf(buf,"%d", cref[i].prrel);
		m_ListRef.SetItemText( i, 2, buf  );

		sprintf(buf,"%d", cref[i].delay);
		m_ListRef.SetItemText( i, 3, buf  );

		sprintf(buf,"%d", cref[i].relcontact);
		m_ListRef.SetItemText( i, 4, buf  );


	}

	_close(handle);




}



void CBMFBioUPIDemoDlg::OnKeydownListusers(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	CString	str;
	
	*pResult = 0;


	return;

	status_click = 0;

	current_row = m_ListUsers.GetNextItem( -1, LVNI_ALL | LVNI_FOCUSED);

	POSITION pos = m_ListUsers.GetFirstSelectedItemPosition();

	current_row = (int)pos;
	
	if ( current_row == -1 )	return;

	str = m_ListUsers.GetItemText(current_row, 0);
	SetDlgItemText(IDC_EDITFNAME,    str);
	
	str = m_ListUsers.GetItemText(current_row, 1);
	SetDlgItemText(IDC_EDITLNAME,    str);

}


BOOL CBMFBioUPIDemoDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
	
	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

void CBMFBioUPIDemoDlg::OnSetfocusListusers(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

CScrollBar* CBMFBioUPIDemoDlg::GetScrollBarCtrl(int nBar) const
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::GetScrollBarCtrl(nBar);
}

BOOL CBMFBioUPIDemoDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::OnCommand(wParam, lParam);
}

void CBMFBioUPIDemoDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CBMFBioUPIDemoDlg::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnKeyUp(nChar, nRepCnt, nFlags);
}

int CBMFBioUPIDemoDlg::OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex) 
{
	// TODO: Add your message handler code here and/or call default
	
	return CDialog::OnVKeyToItem(nKey, pListBox, nIndex);
}


void CBMFBioUPIDemoDlg::ButtonOn()
{
GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);
}

void CBMFBioUPIDemoDlg::ButtonOff()
{
GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
}



void CBMFBioUPIDemoDlg::OnAddref() 
{
	// TODO: Add your control notification handler code here
	char buf[25];
	CString	ipadd_s;
	CString	iprel_r;
	short	prrel;
	short	delay;
	short	relcontact;

	GetDlgItemText(IDC_IPADDRESS_S, ipadd_s);
	GetDlgItemText(IDC_IPADDRESS_R, iprel_r);
	prrel = GetDlgItemInt(IDC_PRREL);
	delay = GetDlgItemInt(IDC_DELAY);
	relcontact = GetDlgItemInt(IDC_NUMCON);
	

	strcpy((char *)cref[numref_row].ipscn, ipadd_s.GetBuffer(0));
	strcpy((char *)cref[numref_row].iprel, iprel_r.GetBuffer(0));
	cref[numref_row].prrel = prrel;
	cref[numref_row].delay = delay;
	cref[numref_row].relcontact = relcontact;

	m_ListRef.InsertItem( numref_row, ipadd_s );
		
	m_ListRef.SetItemText( numref_row, 0, (char *)cref[numref_row].ipscn);
	m_ListRef.SetItemText( numref_row, 1, (char *)cref[numref_row].iprel);
	sprintf(buf,"%d", cref[numref_row].prrel);
	m_ListRef.SetItemText( numref_row, 2, buf  );

	sprintf(buf,"%d", cref[numref_row].delay);
	m_ListRef.SetItemText( numref_row, 3, buf  );

	sprintf(buf,"%d", cref[numref_row].relcontact);
	m_ListRef.SetItemText( numref_row, 4, buf  );
	
	numref_row++;	
}


void CBMFBioUPIDemoDlg::OnClickListref(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	CString	str;

	*pResult = 0;

	curref_row = m_ListRef.GetNextItem( -1, LVNI_ALL | LVNI_FOCUSED);

	if ( curref_row == -1 )	return;

	status_click = 1;

	str = m_ListRef.GetItemText(curref_row, 0);
	SetDlgItemText(IDC_IPADDRESS_S,    str);
	
	str = m_ListRef.GetItemText(curref_row, 1);
	SetDlgItemText(IDC_IPADDRESS_R,    str);

	str = m_ListRef.GetItemText(curref_row, 2);
	SetDlgItemText(IDC_PRREL,    str);

	str = m_ListRef.GetItemText(curref_row, 3);
	SetDlgItemText(IDC_DELAY,    str);

	str = m_ListRef.GetItemText(curref_row, 4);
	SetDlgItemText(IDC_NUMCON,    str);

}


void CBMFBioUPIDemoDlg::OnDelref() 
{
	// TODO: Add your control notification handler code here
	int	i;

	if ( curref_row == -1 )	{
		MessageBox("The user isn't selected", "Delete", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}
	if ( status_click == 0 ) {
		MessageBox("Please, select line by mouse", "Delete", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}

	for(i = curref_row; i < (numref_row-1); i++) {
		cref[i] = cref[i+1];
	}

	m_ListRef.DeleteItem(curref_row);
	numref_row--;
}



void CBMFBioUPIDemoDlg::OnServer() 
{
	// TODO: Add your control notification handler code here
		// TODO: Add your control notification handler code here
	if ( TreatStatusServ == FALSE )  {
		TreatStatusServ = TRUE;
		m_IsComp1to1= TRUE;
		SetDlgItemText(IDC_SERVER,"Server (Active)");
		ScanThreadServ = AfxBeginThread(ThreadServer,this);
		Sleep(500);	
	}
	else {
		TreatStatusServ = FALSE;
		SetDlgItemText(IDC_SERVER,"Server (No Active)");
	}

	
}

void CBMFBioUPIDemoDlg::OnClickListmsg(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int	row;

	CString	str;
	
	*pResult = 0;

	row = m_ListMsg.GetNextItem( -1, LVNI_ALL | LVNI_FOCUSED);

	if ( row == -1 )	return;

	str = m_ListMsg.GetItemText(row, 0);
	SetDlgItemText(IDC_STATUSINFO,    str);
}


/*
*/
void CBMFBioUPIDemoDlg::OnConnect() 
{
// TODO: Add your control notification handler code here
int	port;
CString	str;

GetDlgItemText(IDC_IPADDRESS2,str);
port = GetDlgItemInt(IDC_PORT2);

if ( TreatStatus == TRUE )  {
	MessageBox("You have the connection.");
	return;
}

handle = -1;

efisEnableYellowLED();

if ( (handle = efisOpenDevice(TYPESCANNER_EFIS321, (unsigned char *)str.GetBuffer(0),port)) >= 0 ) {
	MessageBox("Connected");
}
else {
	handle = -1;
	MessageBox("No Connect");
	return;
}

GetDlgItem(IDC_TRANING)->EnableWindow(TRUE);
GetDlgItem(IDC_ENROLLMENT)->EnableWindow(TRUE);
GetDlgItem(IDC_IDEN)->EnableWindow(TRUE);
GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);
GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);

GetDlgItem(IDC_GREEN)->EnableWindow(TRUE);
GetDlgItem(IDC_RED)->EnableWindow(TRUE);

m_IsTraining = FALSE;
m_IsEnroll = FALSE;	
m_IsComp1to1= FALSE;
m_IsComp1toN= FALSE;


TreatStatus = TRUE;
ScanThread = AfxBeginThread(ThreadScanner,this);


UpdateData(FALSE);
}



void CBMFBioUPIDemoDlg::OnDisconnect() 
{
	// TODO: Add your control notification handler code here
if ( TreatStatus != FALSE )  {
	TreatStatus = FALSE;
	if ( ScanThread !=NULL ) {
		WaitForSingleObject(ScanThread->m_hThread,INFINITE);
	}
}

if ( m_green == TRUE ) {
	m_green = FALSE;
	SetDlgItemText(IDC_GREEN,"Green OFF");
	efisLedOFF(handle, LED1_GREEN_OFF);
}

if ( m_red == TRUE ) {
	m_red = FALSE;
	SetDlgItemText(IDC_RED,"Red OFF");
	efisLedOFF(handle, LED1_RED_OFF);
}


if ( handle != -1 )	 {
	efisCloseDevice(handle);
	handle = -1;
}

GetDlgItem(IDC_TRANING)->EnableWindow(FALSE);
GetDlgItem(IDC_ENROLLMENT)->EnableWindow(FALSE);
GetDlgItem(IDC_IDEN)->EnableWindow(FALSE);

GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);

GetDlgItem(IDC_GREEN)->EnableWindow(FALSE);
GetDlgItem(IDC_RED)->EnableWindow(FALSE);

SetDlgItemText(IDC_TRANING,"Training");
SetDlgItemText(IDC_IDEN,"Identification");
SetDlgItemText(IDC_ENROLLMENT,"Enrollment");

m_IsTraining = FALSE;

m_IsEnroll = FALSE;	
m_IsComp1to1= FALSE;
m_IsComp1toN= FALSE;
}

void CBMFBioUPIDemoDlg::OnGreen() 
{
	// TODO: Add your control notification handler code here
	//GetDlgItem(IDC_RED)->EnableWindow(FALSE);
	if ( m_green == FALSE ) {
		m_green = TRUE;
		SetDlgItemText(IDC_GREEN,"Green ON");
		efisLedON(handle, LED1_GREEN_ON);		
	}
	else {
		m_green = FALSE;
		SetDlgItemText(IDC_GREEN,"Green OFF");
		efisLedOFF(handle, LED1_GREEN_OFF);
	}
	//Sleep(300);
	//GetDlgItem(IDC_RED)->EnableWindow(TRUE);
}

void CBMFBioUPIDemoDlg::OnRed() 
{
	// TODO: Add your control notification handler code here
	//GetDlgItem(IDC_GREEN)->EnableWindow(FALSE);
	if ( m_red == FALSE ) {
		m_red = TRUE;
		SetDlgItemText(IDC_RED,"Red ON");
		efisLedON(handle, LED1_RED_ON);
	}
	else {
		m_red = FALSE;
		SetDlgItemText(IDC_RED,"Red OFF");
		efisLedOFF(handle, LED1_RED_OFF);
	}
	//Sleep(300);
	//GetDlgItem(IDC_GREEN)->EnableWindow(TRUE);
}

void CBMFBioUPIDemoDlg::OnAccessrelay() 
{
	// TODO: Add your control notification handler code here
	m_access_relay = IsDlgButtonChecked(IDC_ACCESSRELAY);	
	
}
