// BMFBioUPIDemoTrt.cpp : implementation file
//

#include "stdafx.h"
#include "BMFBioUPIDemo.h"
#include "BMFBioUPIDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


int	Detect( unsigned char *imagin, signed short th, short *pdisp);


UINT	CBMFBioUPIDemoDlg::ThreadScanner(LPVOID Par)
{
int	ret;
CBMFBioUPIDemoDlg* m_Dlg = (CBMFBioUPIDemoDlg*)Par;

if ( m_Dlg->handle < 0 )	return	1;

ProcTemp	b(MBF, 50);

efisLedON(m_Dlg->handle, LED1_YELLOW_ON);

	
while(1) {
	WaitForSingleObject(m_Dlg->s_DoEvent,INFINITE);

	if  ( TreatStatus == FALSE )	break;

	ret = efisIsFingerPresentV2(m_Dlg->handle);

	if ( ret == rcOK ) {

		if ( efisIsFingerPresent(m_Dlg->handle) == rcOK ) {
			efisGetImage(m_Dlg->handle, m_Dlg->pimg);

			m_Dlg->Himg = efisGetHeight(m_Dlg->handle);
			m_Dlg->Wimg = efisGetWidth(m_Dlg->handle);

			m_Dlg->MyPaint();
			m_Dlg->ControlEvents(b);

		}
	}
	else {
		//efisLedON(m_Dlg->handle, LED1_YELLOW_ON);
		//efisLedOFF(m_Dlg->handle, LED1_YELLOW_OFF);
		Sleep(100);
	}
}


return	0;
}



int	CBMFBioUPIDemoDlg::ControlEvents(ProcTemp & b)
{
char	msg[128], bid[32];
int	ret;
CWnd* pWnd = GetDlgItem(IDC_STATUSINFO);
CString	str;
int	ID;

clock_t start, finish;

if ( countmis == 0 ) {
	countmis++;
	return	1;
}
else {
	countmis = 0;
}

if  ( m_IsEnroll == TRUE ) {
		strnset((char *)btmp, 0, 2048);
		ret = b.CreateTemplate(pimg, Wimg, Himg, btmp, status);
		counter++;

		if  ( ret == 1 && counter >= 5 ) {
			SetDlgItemText(IDC_STATUS,    "Templete is created");
			
			sprintf(msg, "Template is created (%d) tmpQ (%d)", counter, b.GetQualityTemplate(btmp) );
			SetDlgItemText(IDC_STATUSINFO,msg);
			m_IsEnroll = FALSE;

			sprintf(msg, "Templete is created. Q = (%d)", b.GetQualityTemplate(btmp));
			MessageBox(msg, "Enrollment", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);

			str = m_ListUsers.GetItemText(current_row, 2);
			ID = atoi(str.GetBuffer(0));

			memmove(tempu[number_tmp].temp, btmp, 2048);
			tempu[number_tmp].flag = 1;
			tempu[number_tmp].ID = ID;
			number_tmp++;

			ret = CalcTemplates(ID);
			if ( ret == 0 )	sprintf(bid,"No (%d)",  ret);
			else			sprintf(bid,"Yes (%d)", ret);
			m_ListUsers.SetItemText( current_row, 3, bid  );

			current_row = -1;
			
			m_IsEnroll  = FALSE; 
			//TreatStatus = FALSE;
			SetDlgItemText(IDC_ENROLLMENT,"Enrollment");
			SetDlgItemText(IDC_STATUS, " ");
			GetDlgItem(IDC_TRANING)->EnableWindow(TRUE);
			GetDlgItem(IDC_IDEN)->EnableWindow(TRUE);

		}
		else {
			if ( counter >=9 )	{
				sprintf(msg, "Template is not created");
				SetDlgItemText(IDC_STATUSINFO,msg);
				m_IsEnroll = FALSE;
			}

			SetDlgItemText(IDC_STATUSINFO,"Take away the finger");
			//MessageBox("Remove your finger and put again","Enrollment", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
			sprintf(msg, "Please, put your finger on the scanner (%d)", status);
			SetDlgItemText(IDC_STATUSINFO, msg);
		}
}

if  ( m_IsComp1to1 == TRUE ) {

	b.IdentifyInit(pimg, Wimg, Himg);

	int	i;

	start = clock();
	for(i = 0; i < number_tmp; i++) {
		ret = b.IdentifyFind(tempu[i].temp);
		if ( ret >= 17 )	break;
	}
	finish = clock();
	
	if  ( ret >= 17 ) {
		sprintf(msg, "Person is verified %d, %d, %2.4f", tempu[i].ID, ret, (finish-start)/1000. );
		efisLedON(handle, LED1_GREEN_ON);
		//efisLedTimer(handle, LED1_GREEN_ON, 3);
		MessageBox(msg, "Verification", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
		Sleep(1000);
		efisLedOFF(handle, LED1_GREEN_OFF);
		counter = 0;
	}
	else {
		if ( counter == 1 ) {
			efisLedON(handle, LED1_RED_ON);
			//efisLedTimer(handle, LED1_RED_ON, 2);
			sprintf(msg, "Person is not verified");
			MessageBox(msg, "Verification", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
			Sleep(1000);
			efisLedOFF(handle, LED1_RED_OFF);
			counter = 0;
		}	
		else {
			counter++;
		}
		
	}
}


return	1;
}



