// BMFBioUPIDemoDlg.h : header file
//

#if !defined(AFX_BMFBIOUPIDEMODLG_H__60AF3047_D89C_11D6_9633_00A0C9E36742__INCLUDED_)
#define AFX_BMFBIOUPIDEMODLG_H__60AF3047_D89C_11D6_9633_00A0C9E36742__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "efisc.h"
//#include "bioupic.h"
#include "bioupi.h"


typedef struct {
	unsigned char ipscn[16];

	unsigned char iprel[16];
	short		  prrel;
	short		  delay;
	short		  relcontact;
}	ConRef;


/////////////////////////////////////////////////////////////////////////////
// CBMFBioUPIDemoDlg dialog

class CBMFBioUPIDemoDlg : public CDialog
{
// Construction
public:

	SOCKADDR_IN accept_sin;		// Receives the address of the connecting entity
	int accept_sin_len;         // Length of accept_sin
	SOCKET	ClientSock;			// Socket for communicating between the server and client
	int		handleEFIS;
	int		handle;


	CBMFBioUPIDemoDlg(CWnd* pParent = NULL);	// standard constructor

	static UINT ThreadScanner(LPVOID Par);
	int	ControlEvents(ProcTemp & b);

	//static UINT ThreadScannerRS(LPVOID Par);
	//int	ControlEventsRS(void);

	static UINT ThreadServer(LPVOID Par);

	static UINT ThreadEFISScanner(LPVOID Par);
	int	ControlEFISEvents(int handle, unsigned char * ptr_img, int W, int H, char * in_addr, ProcTemp & b);

	void MyPaint(void);
	void MyPaint(unsigned char * ptr_img, int W, int H);

	int	CalcTemplates(int ID);
	void Deletetmp(int ID);

	HANDLE s_DoEvent; 
	int	rc;
	byte * pimg;
	int	Himg;
	int	Wimg;

	int	m_IsTraining;

	int	m_IsEnroll;
	int	m_IsComp1to1;
	int	m_IsComp1toN;

	int	m_green;
	int	m_red;

	byte  btmp[2048];
	int	  counter;
	int	  countmis;
	short status;

	int	status_click;

	//	list of users
	int	number_row;
	int	current_row;
	UserData users[MAX_USERS];

	int	number_tmp;
	int	current_tmp;
	TempData tempu[MAX_USERS];

	int	numref_row;
	int	curref_row;
	ConRef	 cref[90];

	int	nummsg_row;

	char	ipaddress[36];
	char	ipport[10];


	HANDLE hComm;
	char bcmd[128];
	int	m_IsCommand;


	BOOL	WriteABuffer(char * lpBuf, DWORD dwToWrite);
	BOOL	ReadABuffer(char * lpBuf, DWORD dwToRead);
	char *	RunCommand(char * cmd, int len);
	char *  GetAnswer(int len);
	//int		Connect(void);
	//void    Disconnect(void);
	void	GetImage(void) ;
	void    IsGetImage(void);
	void    ReadyGetImage(void);
	void    GetInfo(void);
	void    DBUsers(void);


	//int		rs232WriteTemplateToIFIS(unsigned char * buf, int size);
	//int		rs232ReadTemplateFromIFIS(unsigned char * buf, int size);
	//int		rs232DeleteTemplateInIFIS(void);

	void	ButtonOn(void);
	void	ButtonOff(void);

	int		GetConfig(void);
	int		PutConfig(void);



		// Dialog Data
	//{{AFX_DATA(CBMFBioUPIDemoDlg)
	enum { IDD = IDD_BMFBIOUPIDEMO_DIALOG };
	CListCtrl	m_ListMsg;
	CListCtrl	m_ListRef;
	CListCtrl	m_ListUsers;
	CButton	m_Training;
	CButton	m_Enroll;
	BOOL	m_access_relay;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBMFBioUPIDemoDlg)
	public:
	virtual CScrollBar* GetScrollBarCtrl(int nBar) const;
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	
	// Generated message map functions
	//{{AFX_MSG(CBMFBioUPIDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTraning();
	virtual void OnOK();
	afx_msg void OnAdduser();
	afx_msg void OnModifyuser();
	afx_msg void OnDeleteuser();
	afx_msg void OnEnrollment();
	afx_msg void OnIden();
	afx_msg void OnClickListusers(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSavelist();
	afx_msg void OnLoadfile();
	afx_msg void OnKeydownListusers(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnSetfocusListusers(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg int OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex);
	afx_msg void OnAddref();
	afx_msg void OnDelref();
	afx_msg void OnClickListref(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnServer();
	afx_msg void OnClickListmsg(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnGreen();
	afx_msg void OnRed();
	afx_msg void OnAccessrelay();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//extern	ProcTemp *match;
//extern	int	DevHand;

extern	BOOL	TreatStatus;
extern	CWinThread* ScanThread;

//extern	BOOL	TreatStatusRS;
//extern	CWinThread* ScanThreadRS;

extern	BOOL	TreatStatusServ;
extern	CWinThread* ScanThreadServ;

extern	HANDLE  hMutex_app;



#define	CMD_NOCOMMAND	0
#define	CMD_CONNECT		1000
#define	CMD_DISCONNECT	9999
#define	CMD_RESET		9000
#define	CMD_GETIMAGE	2000
#define	CMD_ISGETIMAGE	2001
#define	CMD_RDYGETIMAGE	2002

#define	CMD_LOADCONFIG	2005
#define	CMD_SAVECONFIG	2006

#define	CMD_GETINFO		8000
#define	CMD_USERS		10000
#define	CMD_READUSERS	3000
#define	CMD_WRITEUSERS	4000
#define	CMD_ENROLL		5000


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BMFBIOUPIDEMODLG_H__60AF3047_D89C_11D6_9633_00A0C9E36742__INCLUDED_)
