// TCPWINDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Afxwin.h"
#include "TCPWIN.h"
#include "TCPWINDlg.h"
#include <windows.h>
#include "erel11xc.h"

#include "io.h"
#include "fcntl.h"
#include <sys/stat.h>



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//DevEFIS	dev;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTCPWINDlg dialog

CTCPWINDlg::CTCPWINDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTCPWINDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTCPWINDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	TreatStatus  = FALSE;
	TreatStatus1 = FALSE;
	handle = -1;
}

void CTCPWINDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTCPWINDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTCPWINDlg, CDialog)
	//{{AFX_MSG_MAP(CTCPWINDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_READ_STATUS, OnReadStatus)
	ON_BN_CLICKED(IDC_RELAY_1_ON, OnRelay1On)
	ON_BN_CLICKED(IDC_RELAY_2_ON, OnRelay2On)
	ON_BN_CLICKED(IDC_RELAY_3_ON, OnRelay3On)
	ON_BN_CLICKED(IDC_RELAY_4_ON, OnRelay4On)
	ON_BN_CLICKED(IDC_RELAY_5_ON, OnRelay5On)
	ON_BN_CLICKED(IDC_RELAY_6_ON, OnRelay6On)
	ON_BN_CLICKED(IDC_RELAY_7_ON, OnRelay7On)
	ON_BN_CLICKED(IDC_RELAY_8_ON, OnRelay8On)
	ON_BN_CLICKED(IDC_RELAY_1_OFF, OnRelay1Off)
	ON_BN_CLICKED(IDC_RELAY_2_OFF, OnRelay2Off)
	ON_BN_CLICKED(IDC_RELAY_3_OFF, OnRelay3Off)
	ON_BN_CLICKED(IDC_RELAY_4_OFF, OnRelay4Off)
	ON_BN_CLICKED(IDC_RELAY_5_OFF, OnRelay5Off)
	ON_BN_CLICKED(IDC_RELAY_6_OFF, OnRelay6Off)
	ON_BN_CLICKED(IDC_RELAY_7_OFF, OnRelay7Off)
	ON_BN_CLICKED(IDC_RELAY_8_OFF, OnRelay8Off)
	ON_BN_CLICKED(IDC_CONNECT_IN, OnConnectIn)
	ON_BN_CLICKED(IDC_DISCONNECT_IN, OnDisconnectIn)
	ON_BN_CLICKED(IDC_TEMP, OnTemp)
	ON_BN_CLICKED(IDC_RTIME, OnRtime)
	ON_BN_CLICKED(IDC_WTIME, OnWtime)
	ON_BN_CLICKED(IDC_Relay1Timer, OnRelay1Timer)
	ON_BN_CLICKED(IDC_Relay2Timer, OnRelay2Timer)
	ON_BN_CLICKED(IDC_Relay3Timer, OnRelay3Timer)
	ON_BN_CLICKED(IDC_Relay4Timer, OnRelay4Timer)
	ON_BN_CLICKED(IDC_POWEROF2, OnPowerof2)
	ON_BN_CLICKED(IDC_RCOUNT, OnRcount)
	ON_BN_CLICKED(IDC_RESETCOUNT, OnResetcount)
	ON_BN_CLICKED(IDC_DF_READ, OnDfRead)
	ON_BN_CLICKED(IDC_Relay5Timer, OnRelay5Timer)
	ON_BN_CLICKED(IDC_Relay6Timer, OnRelay6Timer)
	ON_BN_CLICKED(IDC_Relay7Timer, OnRelay7Timer)
	ON_BN_CLICKED(IDC_Relay8Timer, OnRelay8Timer)
	ON_BN_CLICKED(IDC_INPINVERTMASK, OnInpInvertmask)
	ON_BN_CLICKED(IDC_OUTINVERTMASK, OnOutinvertmask)
	ON_BN_CLICKED(IDC_RELAYON, OnRelayon)
	ON_BN_CLICKED(IDC_RELAYOFF, OnRelayoff)
	ON_BN_CLICKED(IDC_STATUSRELAY, OnStatusrelay)
	ON_BN_CLICKED(IDC_CALR, OnCalr)
	ON_BN_CLICKED(IDC_CALW, OnCalw)
	ON_BN_CLICKED(IDC_STATUS, OnStatus)
	ON_BN_CLICKED(IDC_UPDATE, OnUpdate)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTCPWINDlg message handlers

BOOL CTCPWINDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	strcpy(ipaddress,"192.168.100.5");
	strcpy(ipport,"5000");

	this->SetDlgItemText(IDC_IP,ipaddress);
	this->SetDlgItemText(IDC_PORT,ipport);
	this->SetDlgItemText(IDC_PROTOCOL_FILE,"protocol.txt");
	this->SetDlgItemText(IDC_FUPDATE,"erel118.bin");
	

/*
	GetDlgItem(IDC_RELAY_1_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_2_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_3_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_4_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_5_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_6_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_7_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_8_ON)->EnableWindow(FALSE);


	GetDlgItem(IDC_RELAY_1_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_2_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_3_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_4_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_5_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_6_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_7_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_8_OFF)->EnableWindow(FALSE);
*/

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTCPWINDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTCPWINDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTCPWINDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}




#define PORTNUM         5000          // Port number
#define HOSTNAME        "localhost"   // Server name string
                                      // This should be changed
    
char name[20];


SOCKET ServerSock = INVALID_SOCKET; // Socket bound to the server
TCHAR szError[100];                 // Error message string



void CTCPWINDlg::OnConnect() 
{
int	port;
CString	str;
unsigned char st, stat[17];

GetDlgItemText(IDC_IP,str);
port = GetDlgItemInt(IDC_PORT);

if ( TreatStatus == TRUE )  {
	MessageBox("You have the connection.");
	return;
}

handle = -1;

if ( (handle = erelOpenDevice(TYPEDEVICE_EREL112, (unsigned char *)str.GetBuffer(0),port)) == rcOK ) {
	//MessageBox("Connected");
}
else {
	handle = -1;
	MessageBox("No Connect");
	return;
}

erelGetStatusRelay(handle, stat);
st = stat[0];
RelayControl(st);

erelGetStatusInput(handle, stat);
st = stat[0];
InputControl(st);

if ( TreatStatus == FALSE )  {
	TreatStatus = TRUE;
	ScanThread = AfxBeginThread(ThreadScanner,this);

	GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);
	GetDlgItem(IDC_READ_STATUS)->EnableWindow(FALSE);
	GetDlgItem(IDC_CONNECT_IN)->EnableWindow(FALSE);
	GetDlgItem(IDC_DISCONNECT_IN)->EnableWindow(FALSE);
	GetDlgItem(IDC_UPDATE)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_TEMP)->EnableWindow(TRUE);
	GetDlgItem(IDC_RTIME)->EnableWindow(TRUE);
	GetDlgItem(IDC_WTIME)->EnableWindow(TRUE);

	GetDlgItem(IDC_Relay1Timer)->EnableWindow(TRUE);
	GetDlgItem(IDC_Relay2Timer)->EnableWindow(TRUE);
	GetDlgItem(IDC_Relay3Timer)->EnableWindow(TRUE);
	GetDlgItem(IDC_Relay4Timer)->EnableWindow(TRUE);
	GetDlgItem(IDC_Relay5Timer)->EnableWindow(TRUE);
	GetDlgItem(IDC_Relay6Timer)->EnableWindow(TRUE);
	GetDlgItem(IDC_Relay7Timer)->EnableWindow(TRUE);
	GetDlgItem(IDC_Relay8Timer)->EnableWindow(TRUE);

	GetDlgItem(IDC_INPINVERTMASK)->EnableWindow(TRUE);
	GetDlgItem(IDC_OUTINVERTMASK)->EnableWindow(TRUE);
		
	UpdateData(FALSE);
}
}

/*
*/
void CTCPWINDlg::OnDisconnect() 
{
if ( TreatStatus != FALSE )  {
	TreatStatus = FALSE;
	Sleep(500);
	if ( ScanThread !=NULL ) {
		WaitForSingleObject(ScanThread->m_hThread,2000);
	}
}

if ( handle != -1 )	 {
	erelCloseDevice(handle);
	handle = -1;
}

GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
GetDlgItem(IDC_READ_STATUS)->EnableWindow(TRUE);
GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
GetDlgItem(IDC_UPDATE)->EnableWindow(FALSE);

//GetDlgItem(IDC_CONNECT_IN)->EnableWindow(TRUE);
GetDlgItem(IDC_DISCONNECT_IN)->EnableWindow(FALSE);
GetDlgItem(IDC_TEMP)->EnableWindow(FALSE);
GetDlgItem(IDC_RTIME)->EnableWindow(FALSE);
GetDlgItem(IDC_WTIME)->EnableWindow(FALSE);

GetDlgItem(IDC_Relay1Timer)->EnableWindow(FALSE);
GetDlgItem(IDC_Relay2Timer)->EnableWindow(FALSE);
GetDlgItem(IDC_Relay3Timer)->EnableWindow(FALSE);
GetDlgItem(IDC_Relay4Timer)->EnableWindow(FALSE);
GetDlgItem(IDC_Relay5Timer)->EnableWindow(FALSE);
GetDlgItem(IDC_Relay6Timer)->EnableWindow(FALSE);
GetDlgItem(IDC_Relay7Timer)->EnableWindow(FALSE);
GetDlgItem(IDC_Relay8Timer)->EnableWindow(FALSE);

GetDlgItem(IDC_INPINVERTMASK)->EnableWindow(FALSE);
GetDlgItem(IDC_OUTINVERTMASK)->EnableWindow(FALSE);
}


/*
*/
UINT	CTCPWINDlg::ThreadScanner(LPVOID Par)
{
CTCPWINDlg* m_Dlg = (CTCPWINDlg*)Par;
unsigned char stat[9];
int	count = 0;

// Startup Sensor
	
while(1) {
	//WaitForSingleObject(m_Dlg->s_DoEvent,INFINITE);
	// test on finger

	if  ( TreatStatus == FALSE )	break;
	m_Dlg->OnReadStatus(); //was
	Sleep(500);	//was

	/*
	if ( erelGetStatusInput(m_Dlg->handle, stat) != 0 ) {
		m_Dlg->MessageBox("Networks IerelGetStatusInput error.");
	}
	if ( erelGetStatusRelay(m_Dlg->handle, stat) != 0 ) {
		m_Dlg->MessageBox("Networks erelGetStatusRelay error.");
	}
	count++;

	if ( count == 100 ) {
		erelRelayOn(m_Dlg->handle, 0x11);
		erelRelayOff(m_Dlg->handle, 0x11);
		count = 0;
	}

	*/

	if  ( TreatStatus == FALSE )	break;
}

return	0;
}


/*
*/
void CTCPWINDlg::OnOK() 
{
	// TODO: Add extra validation here

	OnDisconnect();
	
	CDialog::OnOK();
}


/*
*/
void CTCPWINDlg::OnReadStatus() 
{
	// TODO: Add your control notification handler code here
int	port, status = 0;
CString	str;
unsigned char st, stat[17];

GetDlgItemText(IDC_IP,str);
port = GetDlgItemInt(IDC_PORT);

if ( handle == -1 ) {
	status = -1;
	if ( (handle = erelOpenDevice(TYPEDEVICE_EREL112, (unsigned char *)str.GetBuffer(0),port)) == rcOK ) {
		//	MessageBox("Connected");
	}
	else {
		handle = -1;
		MessageBox("No Connect");
		return;
	}
}

if ( status == -1 ) {
	erelGetStatusRelay(handle, stat);
	st = stat[0];
	RelayControl(st);
}

erelGetStatusInput(handle, stat);
st = stat[0];
InputControl(st);

//UpdateData(FALSE);

if ( handle != -1 && status == -1 )	 {
	erelCloseDevice(handle);
	handle = -1;
}
}

void	CTCPWINDlg::RelayControl(unsigned char st)
{
if ( (st&0x01) == 0x01 ) {
	GetDlgItem(IDC_RELAY_1_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_1_OFF)->EnableWindow(TRUE);
}
else {
	GetDlgItem(IDC_RELAY_1_ON)->EnableWindow(TRUE);
	GetDlgItem(IDC_RELAY_1_OFF)->EnableWindow(FALSE);
}


if ( (st&0x02) == 0x02 ) {
	GetDlgItem(IDC_RELAY_2_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_2_OFF)->EnableWindow(TRUE);
}
else {
	GetDlgItem(IDC_RELAY_2_ON)->EnableWindow(TRUE);
	GetDlgItem(IDC_RELAY_2_OFF)->EnableWindow(FALSE);
}


if ( (st&0x04) == 0x04 ) {
	GetDlgItem(IDC_RELAY_3_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_3_OFF)->EnableWindow(TRUE);
}
else {
	GetDlgItem(IDC_RELAY_3_ON)->EnableWindow(TRUE);
	GetDlgItem(IDC_RELAY_3_OFF)->EnableWindow(FALSE);
}


if ( (st&0x08) == 0x08 ) {
	GetDlgItem(IDC_RELAY_4_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_4_OFF)->EnableWindow(TRUE);
}
else {
	GetDlgItem(IDC_RELAY_4_ON)->EnableWindow(TRUE);
	GetDlgItem(IDC_RELAY_4_OFF)->EnableWindow(FALSE);
}


if ( (st&0x10) == 0x10 ) {
	GetDlgItem(IDC_RELAY_5_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_5_OFF)->EnableWindow(TRUE);
}
else {
	GetDlgItem(IDC_RELAY_5_ON)->EnableWindow(TRUE);
	GetDlgItem(IDC_RELAY_5_OFF)->EnableWindow(FALSE);
}


if ( (st&0x20) == 0x20 ) {
	GetDlgItem(IDC_RELAY_6_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_6_OFF)->EnableWindow(TRUE);
}
else {
	GetDlgItem(IDC_RELAY_6_ON)->EnableWindow(TRUE);
	GetDlgItem(IDC_RELAY_6_OFF)->EnableWindow(FALSE);
}


if ( (st&0x40) == 0x40 ) {
	GetDlgItem(IDC_RELAY_7_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_7_OFF)->EnableWindow(TRUE);
}
else {
	GetDlgItem(IDC_RELAY_7_ON)->EnableWindow(TRUE);
	GetDlgItem(IDC_RELAY_7_OFF)->EnableWindow(FALSE);
}


if ( (st&0x80) == 0x80 ) {
	GetDlgItem(IDC_RELAY_8_ON)->EnableWindow(FALSE);
	GetDlgItem(IDC_RELAY_8_OFF)->EnableWindow(TRUE);
}
else {
	GetDlgItem(IDC_RELAY_8_ON)->EnableWindow(TRUE);
	GetDlgItem(IDC_RELAY_8_OFF)->EnableWindow(FALSE);
}
}


void	CTCPWINDlg::InputControl(unsigned char st)
{
if ( (st&0x01) == 0x01 ) {
	GetDlgItem(IDC_INPUTM_1)->EnableWindow(FALSE);
	SetDlgItemText(IDC_INPUTM_1,"Input 1 OFF");
}
else {
	GetDlgItem(IDC_INPUTM_1)->EnableWindow(TRUE);
	SetDlgItemText(IDC_INPUTM_1,"Input 1 ON");
}


if ( (st&0x02) == 0x02 ) {
	GetDlgItem(IDC_INPUTM_2)->EnableWindow(FALSE);
	SetDlgItemText(IDC_INPUTM_2,"Input 2 OFF");
}
else {
	GetDlgItem(IDC_INPUTM_2)->EnableWindow(TRUE);
	SetDlgItemText(IDC_INPUTM_2,"Input 2 ON");
}


if ( (st&0x04) == 0x04 ) {
	GetDlgItem(IDC_INPUTM_3)->EnableWindow(FALSE);
	SetDlgItemText(IDC_INPUTM_3,"Input 3 OFF");
}
else {
	GetDlgItem(IDC_INPUTM_3)->EnableWindow(TRUE);
	SetDlgItemText(IDC_INPUTM_3,"Input 3 ON");
}


if ( (st&0x08) == 0x08 ) {
	GetDlgItem(IDC_INPUTM_4)->EnableWindow(FALSE);
	SetDlgItemText(IDC_INPUTM_4,"Input 4 OFF");
}
else {
	GetDlgItem(IDC_INPUTM_4)->EnableWindow(TRUE);
	SetDlgItemText(IDC_INPUTM_4,"Input 4 ON");
}

if ( (st&0x10) == 0x10 ) {
	GetDlgItem(IDC_INPUTM_5)->EnableWindow(FALSE);
	SetDlgItemText(IDC_INPUTM_5,"Input 5 OFF");
}
else {
	GetDlgItem(IDC_INPUTM_5)->EnableWindow(TRUE);
	SetDlgItemText(IDC_INPUTM_5,"Input 5 ON");
}


if ( (st&0x20) == 0x20 ) {
	GetDlgItem(IDC_INPUTM_6)->EnableWindow(FALSE);
	SetDlgItemText(IDC_INPUTM_6,"Input 6 OFF");
}
else {
	GetDlgItem(IDC_INPUTM_6)->EnableWindow(TRUE);
	SetDlgItemText(IDC_INPUTM_6,"Input 6 ON");
}


if ( (st&0x40) == 0x40 ) {
	GetDlgItem(IDC_INPUTM_7)->EnableWindow(FALSE);
	SetDlgItemText(IDC_INPUTM_7,"Input 7 OFF");
}
else {
	GetDlgItem(IDC_INPUTM_7)->EnableWindow(TRUE);
	SetDlgItemText(IDC_INPUTM_7,"Input 7 ON");
}



if ( (st&0x80) == 0x80 ) {
	GetDlgItem(IDC_INPUTM_8)->EnableWindow(FALSE);
	SetDlgItemText(IDC_INPUTM_8,"Input 8 OFF");
}
else {
	GetDlgItem(IDC_INPUTM_8)->EnableWindow(TRUE);
	SetDlgItemText(IDC_INPUTM_8,"Input 8 ON");
}

}

void	CTCPWINDlg::SendCommandToEREL(unsigned char cmd, int action)
{
int	port, ret, status = 0;
CString	str;

GetDlgItemText(IDC_IP,str);
port = GetDlgItemInt(IDC_PORT);

if ( handle == -1 ) {
	status = -1;
	if ( (handle = erelOpenDevice(TYPEDEVICE_EREL112, (unsigned char *)str.GetBuffer(0),port)) == rcOK ) {
	//	MessageBox("Connected");
	}
	else {
		handle = -1;
		MessageBox("No Connect");
		return;
	}
}

//erelRelaySwitchByte(handle, 1);

if ( action == 1 ) {
	ret = erelRelayOn(handle, cmd);
}

if ( action == 0 ) {
	ret = erelRelayOff(handle, cmd);
}

if ( ret >= 0 ) {
	RelayControl(ret);
}

//Sleep(500);

if ( handle != -1 && status == -1 )	 {
	erelCloseDevice(handle);
	handle = -1;
}

if ( status == -1 ) OnReadStatus();	//	need uncomment
}


void CTCPWINDlg::OnRelay1On() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x01, 1);
}

void CTCPWINDlg::OnRelay2On() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x02, 1);
}


void CTCPWINDlg::OnRelay3On() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x04, 1);	
}

void CTCPWINDlg::OnRelay4On() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x08, 1);	
}


void CTCPWINDlg::OnRelay5On() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x10, 1);	
}

void CTCPWINDlg::OnRelay6On() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x20, 1);	
}

void CTCPWINDlg::OnRelay7On() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x40, 1);	
}

void CTCPWINDlg::OnRelay8On() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x80, 1);	
}


void CTCPWINDlg::OnRelay1Off() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x01, 0);		
}

void CTCPWINDlg::OnRelay2Off() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x02, 0);			
}


void CTCPWINDlg::OnRelay3Off() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x04, 0);		
}


void CTCPWINDlg::OnRelay4Off() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x08, 0);		
}


void CTCPWINDlg::OnRelay5Off() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x10, 0);			
}

void CTCPWINDlg::OnRelay6Off() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x20, 0);			
}

void CTCPWINDlg::OnRelay7Off() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x40, 0);		
}

void CTCPWINDlg::OnRelay8Off() 
{
	// TODO: Add your control notification handler code here
	SendCommandToEREL(0x80, 0);			
}



UINT	CTCPWINDlg::ThreadScanner1(LPVOID Par)
{
CTCPWINDlg* m_Dlg = (CTCPWINDlg*)Par;
int	 ret;
unsigned char	b[128];


erelGetStatusRelay(m_Dlg->handle, b);
m_Dlg->RelayControl(b[0]);

erelGetStatusInput(m_Dlg->handle, b);
m_Dlg->InputControl(b[0]);

erelSendInputStatusOn(m_Dlg->handle);
	
while(1) {
	WaitForSingleObject(m_Dlg->s_DoEvent,INFINITE);

	if  ( TreatStatus1 == FALSE )	break;

	ret = erelGetAnswer(m_Dlg->handle, b);
	if ( ret == 1 ) {
		m_Dlg->InputControl(b[0]);
	}

	if  ( TreatStatus1 == FALSE )	break;

	if ( erelGetStatusRelay(m_Dlg->handle, b) == 0 ) {
		m_Dlg->RelayControl(b[0]);
	}
}

return	0;
}




void CTCPWINDlg::OnConnectIn() 
{
	// TODO: Add your control notification handler code here
int	port;
CString	str;

GetDlgItemText(IDC_IP,str);
port = GetDlgItemInt(IDC_PORT);

if ( TreatStatus == TRUE )  {
	MessageBox("You have the connection.");
	return;
}

handle = -1;

if ( (handle = erelOpenDevice(TYPEDEVICE_EREL112, (unsigned char *)str.GetBuffer(0),port)) == rcOK ) {
	MessageBox("Connected");
}
else {
	handle = -1;
	MessageBox("No Connect");
	return;
}


if ( TreatStatus1 == FALSE )  {
	TreatStatus1 = TRUE;
	ScanThread1 = AfxBeginThread(ThreadScanner1,this);

	GetDlgItem(IDC_CONNECT_IN)->EnableWindow(FALSE);
	GetDlgItem(IDC_DISCONNECT_IN)->EnableWindow(TRUE);
	GetDlgItem(IDC_READ_STATUS)->EnableWindow(FALSE);
	GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
	
	UpdateData(FALSE);
}
}

void CTCPWINDlg::OnDisconnectIn() 
{
	// TODO: Add your control notification handler code here
if ( TreatStatus1 != FALSE )  {
	TreatStatus1 = FALSE;
	if ( ScanThread1 !=NULL ) {
		WaitForSingleObject(ScanThread1->m_hThread,INFINITE);
	}
}

if ( handle != -1 )	 {
	erelCloseDevice(handle);
	handle = -1;
}


GetDlgItem(IDC_CONNECT_IN)->EnableWindow(TRUE);
GetDlgItem(IDC_READ_STATUS)->EnableWindow(TRUE);
GetDlgItem(IDC_DISCONNECT_IN)->EnableWindow(FALSE);
GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
}



void CTCPWINDlg::OnTemp() 
{
int	ret;
double	tm;
char	txt[32];

	// TODO: Add your control notification handler code here
if ( handle == -1 )		return;


ret = erelGetTemperature(handle, &tm);

	
if ( ret == 0 ) {
	SetDlgItemText(IDC_OUTTEMP,"Not connected");
}

if ( ret == 1 ) {
	sprintf((char *)txt,"%4.2f", tm);
	SetDlgItemText(IDC_OUTTEMP, (const char *)txt);
}
}

/*
*/
void CTCPWINDlg::OnRtime() 
{
	// TODO: Add your control notification handler code here

	unsigned char  day, mon, hour, min, sec, dow; 
	unsigned short year;
	char	txt[64];

	//erelGetTime(handle, &day, &mon, &year, &hour, &min, &sec);
	erelGetTimeM3(handle, &day, &mon, &year, &hour, &min, &sec, &dow);
	//erelGetDOW(handle, &dow);


	sprintf(txt,"%d-%d-%d %d:%d:%d\0", day, mon, year, hour, min, sec);

	SetDlgItemText(IDC_TIME, (const char *)txt);

	sprintf(txt,"%d\0", day);
	SetDlgItemText(IDC_DAY, txt);

	sprintf(txt,"%d\0", mon);
	SetDlgItemText(IDC_MON, txt);

	sprintf(txt,"%d\0", year);
	SetDlgItemText(IDC_YEAR, txt);

	//	hour : min
	sprintf(txt,"%d\0", hour);
	SetDlgItemText(IDC_HOUR, txt);

	sprintf(txt,"%d\0", min);
	SetDlgItemText(IDC_MIN, txt);

	if ( dow == 0 ) {
		SetDlgItemText(IDC_DOW, "Sunday");
	}
	if ( dow == 1 ) {
		SetDlgItemText(IDC_DOW, "Monday");
	}
	if ( dow == 2 ) {
		SetDlgItemText(IDC_DOW, "Tuesday");
	}
	if ( dow == 3 ) {
		SetDlgItemText(IDC_DOW, "Wednesday");
	}
	if ( dow == 4 ) {
		SetDlgItemText(IDC_DOW, "Thursday");
	}
	if ( dow == 5 ) {
		SetDlgItemText(IDC_DOW, "Friday");
	}
	if ( dow == 6 ) {
		SetDlgItemText(IDC_DOW, "Saturday");
	}


}

/*
*/
void CTCPWINDlg::OnWtime() 
{
	// TODO: Add your control notification handler code here
	unsigned char  day, mon, hour, min; 
	unsigned short year; 
	
	day  = GetDlgItemInt(IDC_DAY);
	mon  = GetDlgItemInt(IDC_MON);
	year = GetDlgItemInt(IDC_YEAR);
	
	min  = GetDlgItemInt(IDC_MIN);
	hour = GetDlgItemInt(IDC_HOUR);
	

	//erelSetTime(handle, day, mon, year, hour, min, 0);
	erelSetTimeM3(handle, day, mon, year, hour, min, 0);

}

void CTCPWINDlg::OnRelay1Timer() 
{
	// TODO: Add your control notification handler code here
	unsigned char  sec;

	sec  = GetDlgItemInt(IDC_T1R);
	erelRelayOnTimer(handle, 0x01, sec);	
}

void CTCPWINDlg::OnRelay2Timer() 
{
	// TODO: Add your control notification handler code here
	unsigned char  sec;

	sec  = GetDlgItemInt(IDC_T2R);
	erelRelayOnTimer(handle, 0x02, sec);	
}

void CTCPWINDlg::OnRelay3Timer() 
{
	// TODO: Add your control notification handler code here
	unsigned char  sec;

	sec  = GetDlgItemInt(IDC_T3R);
	erelRelayOnTimer(handle, 0x04, sec);
}

void CTCPWINDlg::OnRelay4Timer() 
{
	// TODO: Add your control notification handler code here
	unsigned char  sec;

	sec  = GetDlgItemInt(IDC_T4R);
	erelRelayOnTimer(handle, 0x08, sec);	
}

void CTCPWINDlg::OnPowerof2() 
{
	// TODO: Add your control notification handler code here
	char	bbb[48];	
	unsigned char val;


	if ( handle == -1 )		{
		MessageBox("You don't have a connection");
		return;
	}

	erel_DF_SetPowerOf2M3(handle, &val);
	
	sprintf(bbb, "%x", val);
	SetDlgItemText(IDC_STATUSV, bbb);
}

void CTCPWINDlg::OnRcount() 
{
	// TODO: Add your control notification handler code here
	unsigned long	counter;
	char	buf[25];

	if ( handle == -1 )		{
		MessageBox("You don't have a connection");
		return;
	}


	erel_DF_ReadCounter(handle, &counter);

	sprintf(buf,"%d", counter);

	SetDlgItemText(IDC_EDIT_COUNT,buf);
}

void CTCPWINDlg::OnResetcount() 
{
	// TODO: Add your control notification handler code here
	unsigned long	counter;

	if ( handle == -1 )		{
		MessageBox("You don't have a connection");
		return;
	}

	counter = GetDlgItemInt(IDC_EDIT_COUNT);

	erel_DF_WriteCounter(handle, counter);
	
}


/*
*/
void	ConverToFile(int hf, unsigned char * b)
{
char	txt[512];

unsigned char	day, mon, year, hour, min, sec, user_id;

sec = b[0] & 0x7f;
min = b[1] & 0x7f;
hour = b[2];
day = b[4];
mon = b[5] & 0x1f;
year = b[6];
user_id = b[7];


sprintf(txt,"%d%d-%d%d-%d%d %d%d:%d%d:%d%d user_id = %d\n\0", day>>4,day&0x0f, mon>>4, mon&0x0f, year>>4, year&0x0f, hour>>4, hour&0x0f, min>>4, min&0x0f, sec>>4, sec&0x0f, user_id);

_write(hf, txt, strlen(txt));
}

/*
*/
void CTCPWINDlg::OnDfRead() 
{
	// TODO: Add your control notification handler code here
	unsigned long	counter;
	long	addr;
	unsigned char	b[512];
	int	hf, i, num_512, rest_512;
	CString	str;


	if ( handle == -1 )		{
		MessageBox("You don't have a connection");
		return;
	}

	GetDlgItemText(IDC_PROTOCOL_FILE,str);


	hf = _open(str.GetBuffer(0), O_CREAT | O_WRONLY | O_BINARY | O_TRUNC, 0666 );
	if ( hf == - 1 )	return;


	erel_DF_SaveBuftoMain(handle);
	Sleep(200);

	erel_DF_ReadCounter(handle, &counter);

	num_512 = counter/512;
	rest_512 = counter%512;


	for(addr = 0; addr < num_512; addr+=512) {

		erel_DF_ReadDataFlash(handle, addr, 512, b);

		for(i = 0; i < 512; i+=8) {
			ConverToFile(hf, b + i);
		}
	}

	if ( rest_512 != 0 ) {
		erel_DF_ReadDataFlash(handle, addr, rest_512, b);

		for(i = 0; i < rest_512; i+=8) {
			ConverToFile(hf, b + i);
		}
	}

	_close(hf);

}

void CTCPWINDlg::OnRelay5Timer() 
{
	// TODO: Add your control notification handler code here
	unsigned char  sec;

	sec  = GetDlgItemInt(IDC_T5R);
	erelRelayOnTimer(handle, 0x10, sec);	
}

void CTCPWINDlg::OnRelay6Timer() 
{
	// TODO: Add your control notification handler code here
	unsigned char  sec;

	sec  = GetDlgItemInt(IDC_T6R);
	erelRelayOnTimer(handle, 0x20, sec);		
}

void CTCPWINDlg::OnRelay7Timer() 
{
	// TODO: Add your control notification handler code here
	unsigned char  sec;

	sec  = GetDlgItemInt(IDC_T7R);
	erelRelayOnTimer(handle, 0x40, sec);		
}

void CTCPWINDlg::OnRelay8Timer() 
{
	// TODO: Add your control notification handler code here
	unsigned char  sec;

	sec  = GetDlgItemInt(IDC_T8R);
	erelRelayOnTimer(handle, 0x80, sec);		
}

void CTCPWINDlg::OnInpInvertmask() 
{
	// TODO: Add your control notification handler code here
	unsigned char	mask;
	CString	str;

	str = "           ";

	GetDlgItemText(IDC_SETINPMASK, str);
	mask = (unsigned char)strtol(str.GetBuffer(0),NULL,16);

	erelSetInvertInpMask(handle, mask, 0);

}

void CTCPWINDlg::OnOutinvertmask() 
{
	// TODO: Add your control notification handler code here
	unsigned short	mask;
	CString	str;

	str = "             ";

	GetDlgItemText(IDC_SETOUTMASK, str);
	mask = (unsigned short)strtol(str.GetBuffer(0),NULL,16);


	erelSetInvertOutMask(handle, mask&0x00ff, (mask>>8)&0x00ff);
}

void CTCPWINDlg::OnRelayon() 
{
	// TODO: Add your control notification handler code here
	unsigned short	relay;
	CString	str;

	str = "           ";

	GetDlgItemText(IDC_SETOUTRELAY, str);
	relay = (unsigned short)strtol(str.GetBuffer(0),NULL,16);

	//erelRelayOn(handle, relay);
	erelRelayOnE16(handle, relay);
}

void CTCPWINDlg::OnRelayoff() 
{
	// TODO: Add your control notification handler code here
	unsigned short	relay;
	CString	str;

	str = "           ";

	GetDlgItemText(IDC_SETOUTRELAY, str);
	relay = (unsigned short)strtol(str.GetBuffer(0),NULL,16);

	//erelRelayOff(handle, relay);
	erelRelayOffE16(handle, relay);
}

void CTCPWINDlg::OnStatusrelay() 
{
	// TODO: Add your control notification handler code here
	unsigned short	relaystat;
	unsigned char out[16];
	CString	str;

	erelGetStatusRelayE16(handle, out);

	relaystat = out[1];
	relaystat = relaystat << 8;
	relaystat = relaystat + out[0];

	itoa(relaystat, (char *)out, 16);
	strcpy(str.GetBuffer(0), (char *)out);
	SetDlgItemText(IDC_RELAYSTAT, str);			
}

void CTCPWINDlg::OnCalr() 
{
	// TODO: Add your control notification handler code here
	char	bbb[48];	
	unsigned char val;

	erelGetCalibrationM3(handle, &val);

	sprintf(bbb, "%d", val);
	SetDlgItemText(IDC_CALIBR, bbb);

}

void CTCPWINDlg::OnCalw() 
{
	// TODO: Add your control notification handler code here
	unsigned char val;

	val = GetDlgItemInt(IDC_CALIBR);	

	erelSetCalibrationM3(handle, val);

}

void CTCPWINDlg::OnStatus() 
{
	// TODO: Add your control notification handler code here
	char	bbb[48];	
	unsigned char val;

	erel_DF_ReadStatusM3(handle, &val);
	
	sprintf(bbb, "%x", val);
	SetDlgItemText(IDC_STATUSV, bbb);
}



void CTCPWINDlg::OnUpdate() 
{
	// TODO: Add your control notification handler code here
int	file_handle;
CString	str;
unsigned char * bf;
int	length;

GetDlgItemText(IDC_FUPDATE,str);

file_handle = open(str.GetBuffer(0),O_RDONLY|O_BINARY);
if ( file_handle == -1 )	{ 
	MessageBox("Can't open the file");
	return;
}

length = filelength(file_handle);

bf = (unsigned char * )malloc(length + 1);
if  ( bf == NULL )	{ 
	close(file_handle); 
	MessageBox("Can't alloc memory");
	return; 
}

if ( read(file_handle,(void *)bf,length) != length ) { 
	close(file_handle); 
	free(bf);
	MessageBox("Can't read the file");
	return; 
}

if ( MessageBox("Do you want to update the firmware ? ","Request",MB_YESNO) == IDYES ) {

	if ( handle != -1 )	 {
		if ( erelUpdateFirmwareM3(handle, bf, length) == 1 ) {
			MessageBox("File is written");
		}
		else {
			MessageBox("Error write of file");
		}
		
	}
}

free(bf);
close(file_handle);

	
}

void CTCPWINDlg::OnTest() 
{
	// TODO: Add your control notification handler code here
	unsigned char param[2034];

	//erelGetParamX(handle, param);
	erelGetVersion(handle, param);

}
